package directory.passive.markov;

import java.util.Collection;
import java.util.Map.Entry;

public class Renderer {
	private final Data data;

	public Renderer(Data data) {
		super();
		this.data = data;
	}

	public String render(Collection<Entry<Prefix, Token>> collection) {
		double p = 1;
		StringBuilder sb = new StringBuilder();
		sb.append("KAI-uwe empfiehlt");
		for (Entry<Prefix, Token> t : collection) {
			Lookup lookup = data.fetch(t.getKey());
			int possibilities = lookup.getDistinctTokens();
			p *= (double) lookup.getAmount(t.getValue())
					/ (double) lookup.getTotalCounts();

			if (possibilities <= 1) {
				sb.append("-");
			} else if (possibilities <= 2) {
				sb.append("--");
			} else if (possibilities <= 3) {
				sb.append("---");
			} else if (possibilities <= 5) {
				sb.append("_");
			} else if (possibilities <= 10) {
				sb.append("__");
			} else if (possibilities <= 20) {
				sb.append("___");
			} else if (possibilities <= 50) {
				sb.append("*");
			} else if (possibilities <= 100) {
				sb.append("**");
			} else if (possibilities <= 200) {
				sb.append("***");
			} else {
				sb.append(" ");
			}
			sb.append(t.getValue().render(""));
		}
		sb.append(" - " + p);
		return sb.toString();
	}

}
